cookutils annotate cook @ rev 144

Handle CVS url
author Christophe Lincoln <pankso@slitaz.org>
date Wed May 11 18:29:49 2011 +0200 (2011-05-11)
parents c1f276ae5c0b
children 798f15f2cb06
rev   line source
pankso@1 1 #!/bin/sh
pankso@1 2 #
pankso@1 3 # Cook - A tool to cook and generate SliTaz packages. Read the README
pankso@1 4 # before adding or modifing any code in cook!
pankso@1 5 #
pankso@1 6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
pankso@1 7 # Author: Christophe Lincoln <pankso@slitaz.org>
pankso@1 8 #
pankso@1 9
pankso@1 10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
pankso@1 11 [ -f "cook.conf" ] && . ./cook.conf
pankso@1 12
pankso@16 13 # Share DB and status with the Cooker.
pankso@9 14 activity="$CACHE/activity"
pankso@16 15 command="$CACHE/command"
pankso@11 16 broken="$CACHE/broken"
pankso@47 17 blocked="$CACHE/blocked"
pankso@9 18
pankso@1 19 #
pankso@1 20 # Functions
pankso@1 21 #
pankso@1 22
pankso@1 23 usage() {
pankso@1 24 cat << EOT
pankso@1 25
pankso@1 26 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command|list] [--option]
pankso@1 27
pankso@1 28 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
pankso@1 29 usage|help $(gettext "Display this short usage.")
pankso@1 30 setup $(gettext "Setup your build environment.")
pankso@9 31 test $(gettext "Test environment and cook a package.")
pankso@69 32 list-wok $(gettext "List packages in the wok.")
pankso@69 33 search $(gettext "Simple packages search function.")
paul@62 34 new $(gettext "Create a new package with a receipt".)
pankso@1 35 list $(gettext "Cook a list of packages.")
pankso@1 36 clean-wok $(gettext "Clean-up all packages files.")
paul@62 37 clean-src $(gettext "Clean-up all packages sources.")
pankso@1 38 pkglist $(gettext "Create all packages.* lists.")
pankso@1 39
pankso@1 40 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
pankso@10 41 --clean|-c Cook : $(gettext "clean the package in the wok.")
pankso@39 42 --install|-i Cook : $(gettext "cook and install the package.")
pankso@39 43 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
pankso@49 44 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
pankso@49 45 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
pankso@10 46 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
pankso@1 47
pankso@1 48 EOT
pankso@1 49 exit 0
pankso@1 50 }
pankso@1 51
paul@62 52 # Be sure we're root.
pankso@1 53 check_root() {
pankso@1 54 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
pankso@1 55 }
pankso@1 56
pankso@1 57 separator() {
pankso@1 58 echo "================================================================================"
pankso@1 59 }
pankso@1 60
pankso@1 61 status() {
pankso@1 62 echo -en "\\033[70G[ "
pankso@1 63 if [ $? = 0 ]; then
pankso@1 64 echo -en "\\033[1;32mOK"
pankso@1 65 else
pankso@1 66 echo -en "\\033[1;31mFailed"
pankso@1 67 fi
pankso@1 68 echo -e "\\033[0;39m ]"
pankso@1 69 }
pankso@1 70
pankso@13 71 # Log activities, we want first letter capitalized.
pankso@9 72 log() {
pankso@27 73 grep ^[A-Z] | \
pankso@9 74 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
pankso@9 75 }
pankso@9 76
paul@62 77 # We don't want these escapes in web interface.
pankso@1 78 clean_log() {
pankso@1 79 sed -i -e s'|\[70G\[ \[1;32m| |' \
pankso@1 80 -e s'|\[0;39m \]||' $LOGS/$pkg.log
pankso@1 81 }
pankso@1 82
pankso@23 83 # Log broken packages.
pankso@23 84 broken() {
pankso@74 85 if ! grep -q "^$pkg$" $broken; then
pankso@74 86 echo "$pkg" >> $broken
pankso@74 87 fi
pankso@23 88 }
pankso@23 89
paul@62 90 # Be sure package exists in wok.
pankso@1 91 check_pkg_in_wok() {
pankso@1 92 if [ ! -d "$WOK/$pkg" ]; then
pankso@1 93 gettext -e "\nUnable to find package in the wok:"
pankso@1 94 echo -e " $pkg\n" && exit 1
pankso@1 95 fi
pankso@1 96 }
pankso@1 97
pankso@9 98 if_empty_value() {
pankso@9 99 if [ -z "$value" ]; then
pankso@9 100 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
pankso@9 101 exit 1
pankso@9 102 fi
pankso@9 103 }
pankso@9 104
paul@62 105 # Initialize files used in $CACHE
pankso@52 106 init_db_files() {
pankso@52 107 gettext "Creating directories structure in:"; echo " $SLITAZ"
pankso@52 108 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
pankso@52 109 gettext "Creating DB files in:"; echo " $CACHE"
pankso@52 110 for f in $activity $command $broken $blocked
pankso@52 111 do
pankso@52 112 touch $f
pankso@52 113 done
pankso@52 114 }
pankso@52 115
paul@62 116 # QA: check a receipt consistency before building.
pankso@9 117 receipt_quality() {
pankso@9 118 gettext -e "QA: checking package receipt...\n"
pankso@9 119 unset online
pankso@9 120 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
pankso@9 121 online="online"
pankso@9 122 fi
pankso@9 123 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
pankso@9 124 do
pankso@9 125 unset value
pankso@44 126 value=$(grep ^$var= $receipt | cut -d \" -f 2)
pankso@9 127 case "$var" in
pankso@9 128 PACKAGE|VERSION|SHORT_DESC)
pankso@9 129 if_empty_value ;;
pankso@9 130 CATEGORY)
pankso@9 131 [ -z "$value" ] && value="empty"
pankso@9 132 valid="base-system x-window utilities network graphics \
pankso@9 133 multimedia office development system-tools security games \
pankso@9 134 misc meta non-free"
pankso@9 135 if ! echo "$valid" | grep -q -w "$value"; then
paul@62 136 gettext "QA: unknown category:"; echo -e " $value\n"
pankso@9 137 exit 1
pankso@9 138 fi ;;
pankso@9 139 WEB_SITE)
paul@62 140 # We don't check WGET_URL since if dl is needed it will fail.
paul@62 141 # Break also if we're not online. Here error is not fatal.
pankso@9 142 if_empty_value
pankso@9 143 [ -z "$online" ] || break
pankso@9 144 if ! busybox wget -s $value 2>/dev/null; then
pankso@61 145 gettext "QA: Unable to reach:"; echo -e " $value"
pankso@9 146 fi ;;
pankso@9 147 esac
pankso@9 148 done
pankso@9 149 }
pankso@9 150
pankso@9 151 # Executed before sourcing a receipt.
pankso@9 152 unset_receipt() {
pankso@9 153 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
pankso@9 154 }
pankso@9 155
paul@62 156 # Paths used in receipt and by cook itself.
pankso@1 157 set_paths() {
pankso@1 158 pkgdir=$WOK/$PACKAGE
pankso@1 159 src=$pkgdir/source/$PACKAGE-$VERSION
pankso@44 160 taz=$pkgdir/taz
pankso@44 161 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
pankso@1 162 fs=$pack/fs
pankso@1 163 stuff=$pkgdir/stuff
pankso@1 164 install=$pkgdir/install
pankso@1 165 if [ "$WANTED" ]; then
pankso@1 166 src=$WOK/$WANTED/source/$WANTED-$VERSION
pankso@1 167 install=$WOK/$WANTED/install
pankso@121 168 wanted_stuff=$WOK/$WANTED/stuff
pankso@1 169 fi
pankso@9 170 # Old way compatibility.
pankso@1 171 _pkg=$install
pankso@1 172 }
pankso@1 173
pankso@144 174 # Create source tarball when URL is a SCM.
pankso@144 175 create_tarball() {
pankso@144 176 gettext "Creating tarball: "; echo "$tarball"
pankso@144 177 tar cjf $tarball $pkgsrc || exit 1
pankso@144 178 mv $tarball $SRC && rm -rf $pkgsrc
pankso@144 179 }
pankso@144 180
pankso@9 181 # Get package source.
pankso@1 182 get_source() {
pankso@115 183 pwd=$(pwd)
pankso@144 184 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
pankso@144 185 tarball=$pkgsrc.tar.bz2
pankso@9 186 case "$WGET_URL" in
pankso@140 187 http://*|https://*|ftp://*)
pankso@9 188 # Busybox Wget is better!
pankso@140 189 wget -c -P $SRC $WGET_URL || \
pankso@15 190 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@9 191 hg*|mercurial*)
pankso@9 192 # We are in cache so clone here and create a tarball
pankso@29 193 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
pankso@9 194 url=${WGET_URL#hg|}
pankso@9 195 else
pankso@9 196 url=${WGET_URL#mercurial|}
pankso@9 197 fi
pankso@61 198 gettext -e "Getting source from Hg...\n"
pankso@61 199 echo "URL: $url"
pankso@9 200 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
pankso@15 201 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
pankso@144 202 create_tarball ;;
pankso@9 203 git*)
pankso@61 204 url=${WGET_URL#git|}
pankso@61 205 gettext -e "Getting source from Git...\n"
pankso@61 206 echo "URL: $url"
pankso@64 207 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
pankso@63 208 if [ "$BRANCH" ]; then
pankso@64 209 cd $pkgsrc && git checkout $BRANCH && cd ..
pankso@63 210 fi
pankso@144 211 create_tarball ;;
pankso@144 212 cvs*)
pankso@144 213 url=${WGET_URL#cvs|}
pankso@144 214 mod=$PACKAGE
pankso@144 215 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
pankso@144 216 gettext -e "Getting source from CVS...\n"
pankso@144 217 echo "URL: $url"
pankso@144 218 echo "CVS module: $mod"
pankso@144 219 gettext "Cloning to: "; echo "$pwd/$mod"
pankso@144 220 cvs -d:$url co $mod && mv $mod $pkgsrc
pankso@144 221 create_tarball ;;
pankso@69 222 svn*|subversion*)
pankso@9 223 echo "TODO: svn implementation in cook" && exit 1 ;;
pankso@9 224 *)
pankso@9 225 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
pankso@9 226 tee -a $LOGS/$PACKAGE.log
pankso@9 227 exit 1 ;;
pankso@9 228 esac
pankso@1 229 }
pankso@1 230
pankso@9 231 # Extract source package.
pankso@1 232 extract_source() {
pankso@1 233 gettext "Extracting:"; echo " $TARBALL"
pankso@1 234 case "$TARBALL" in
pankso@120 235 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
pankso@120 236 *.tar.bz2|*.tbz) tar xjf $SRC/$TARBALL 2>/dev/null ;;
pankso@1 237 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
pankso@42 238 *.tar) tar xf $SRC/$TARBALL ;;
pankso@42 239 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
pankso@42 240 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
pankso@42 241 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
pankso@42 242 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
pankso@1 243 esac
pankso@1 244 }
pankso@1 245
pankso@9 246 # Display cooked package summary.
pankso@1 247 summary() {
pankso@1 248 cd $WOK/$pkg
pankso@1 249 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
pankso@1 250 fs=$(du -sh taz/* | awk '{print $1}')
pankso@44 251 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
pankso@44 252 files=$(cat taz/$pkg-*/files.list | wc -l)
pankso@18 253 cookdate=$(date "+%Y-%m-%d %H:%M")
pankso@101 254 sec=$time
pankso@104 255 div=$(($time / 60))
pankso@112 256 [ "$div" != 0 ] && min="~ ${div}m"
pankso@1 257 gettext "Summary for:"; echo " $PACKAGE $VERSION"
pankso@1 258 separator
pankso@67 259 [ "$prod" ] && echo "Produced : $prod"
pankso@1 260 cat << EOT
pankso@1 261 Packed : $fs
pankso@1 262 Compressed : $size
pankso@18 263 Files : $files
pankso@102 264 Cook time : ${sec}s $min
pankso@18 265 Cook date : $cookdate
pankso@1 266 $(separator)
pankso@1 267 EOT
pankso@1 268 }
pankso@1 269
paul@62 270 # Display debugging error info.
pankso@15 271 debug_info() {
pankso@17 272 echo -e "\nDebug information"
pankso@15 273 separator
pankso@48 274 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
pankso@76 275 for error in \
pankso@77 276 ERROR "No package" "cp: can't" "can't open" "can't cd" \
pankso@76 277 "error:" "fatal error:"
pankso@34 278 do
pankso@34 279 fgrep "$error" $LOGS/$pkg.log
pankso@34 280 done
pankso@15 281 separator && echo ""
pankso@15 282 }
pankso@15 283
pankso@1 284 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
pankso@1 285 # so some packages need to copy these files with the receipt and genpkg_rules.
pankso@1 286 copy_generic_files()
pankso@1 287 {
pankso@1 288 # $LOCALE is set in cook.conf
pankso@1 289 if [ "$LOCALE" ]; then
pankso@1 290 if [ -d "$_pkg/usr/share/locale" ]; then
pankso@1 291 mkdir -p $fs/usr/share/locale
pankso@1 292 for i in $LOCALE
pankso@1 293 do
pankso@1 294 if [ -d "$_pkg/usr/share/locale/$i" ]; then
pankso@1 295 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
pankso@1 296 fi
pankso@1 297 done
pankso@1 298 fi
pankso@1 299 fi
pankso@1 300
pankso@1 301 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
pankso@1 302 if [ "$GENERIC_PIXMAPS" != "no" ]; then
pankso@1 303 if [ -d "$_pkg/usr/share/pixmaps" ]; then
pankso@1 304 mkdir -p $fs/usr/share/pixmaps
pankso@1 305 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
pankso@1 306 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 307 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
pankso@1 308 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 309 fi
pankso@1 310
pankso@1 311 # Custom or homemade PNG pixmap can be in stuff.
pankso@1 312 if [ -f "$stuff/$PACKAGE.png" ]; then
pankso@1 313 mkdir -p $fs/usr/share/pixmaps
pankso@1 314 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
pankso@1 315 fi
pankso@1 316 fi
pankso@1 317
pankso@1 318 # Desktop entry (.desktop).
pankso@1 319 if [ -d "$_pkg/usr/share/applications" ]; then
pankso@1 320 cp -a $_pkg/usr/share/applications $fs/usr/share
pankso@1 321 fi
pankso@1 322
pankso@1 323 # Homemade desktop file(s) can be in stuff.
pankso@1 324 if [ -d "$stuff/applications" ]; then
pankso@1 325 mkdir -p $fs/usr/share
pankso@1 326 cp -a $stuff/applications $fs/usr/share
pankso@1 327 fi
pankso@1 328 if [ -f "$stuff/$PACKAGE.desktop" ]; then
pankso@1 329 mkdir -p $fs/usr/share/applications
pankso@1 330 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
pankso@1 331 fi
pankso@1 332 }
pankso@1 333
pankso@67 334 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
pankso@68 335 # as removing uneeded files like in Python packages.
pankso@1 336 strip_package()
pankso@1 337 {
pankso@67 338 gettext "Executing strip on all files..."
pankso@1 339 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
pankso@1 340 do
pankso@1 341 if [ -d "$dir" ]; then
pankso@1 342 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
pankso@1 343 fi
pankso@1 344 done
pankso@1 345 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
pankso@1 346 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
pankso@1 347 status
pankso@67 348
pankso@117 349 # Remove Python .pyc and .pyo from packages.
pankso@117 350 if echo "$DEPENDS" | fgrep -q "python"; then
pankso@68 351 gettext "Removing Python compiled files..."
pankso@67 352 find $fs -type f -name "*.pyc" -delete 2>/dev/null
pankso@67 353 find $fs -type f -name "*.pyo" -delete 2>/dev/null
pankso@117 354 status
pankso@117 355 fi
pankso@117 356
pankso@117 357 # Remove Perl perllocal.pod and .packlist from packages.
pankso@117 358 if echo "$DEPENDS" | fgrep -q "perl"; then
pankso@117 359 gettext "Removing Perl compiled files..."
pankso@67 360 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
pankso@67 361 find $fs -type f -name ".packlist" -delete 2>/dev/null
pankso@67 362 status
pankso@67 363 fi
pankso@1 364 }
pankso@1 365
pankso@8 366 # Remove installed deps.
pankso@8 367 remove_deps() {
pankso@8 368 # Now remove installed build deps.
pankso@113 369 diff="$CACHE/installed.cook.diff"
pankso@113 370 if [ -s "$CACHE/installed.cook.diff" ]; then
pankso@113 371 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
pankso@113 372 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@8 373 gettext "Build dependencies to remove:"; echo " $nb"
pankso@8 374 gettext "Removing:"
pankso@8 375 for dep in $deps
pankso@8 376 do
pankso@8 377 echo -n " $dep"
pankso@8 378 yes | tazpkg remove $dep >/dev/null
pankso@8 379 done
pankso@16 380 echo -e "\n"
pankso@113 381 # Keep the last diff for debug and info.
pankso@113 382 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
pankso@1 383 fi
pankso@1 384 }
pankso@1 385
pankso@1 386 # The main cook function.
pankso@1 387 cookit() {
pankso@11 388 echo "Cook: $PACKAGE $VERSION"
pankso@9 389 separator
pankso@1 390 set_paths
pankso@9 391 [ "$QA" ] && receipt_quality
pankso@44 392 cd $pkgdir
pankso@33 393 rm -rf install taz source
pankso@1 394
pankso@1 395 # Disable -pipe if less than 512Mb free RAM.
pankso@1 396 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
pankso@1 397 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
pankso@1 398 gettext -e "Disabling -pipe compile flag: $free RAM\n"
pankso@1 399 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
pankso@47 400 CXXFLAGS="${CXXFLAGS/-pipe}" && \
pankso@47 401 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
pankso@1 402 fi
pankso@1 403 unset free
pankso@1 404
pankso@1 405 # Export flags and path to be used by make
pankso@44 406 DESTDIR=$pkgdir/install
pankso@1 407 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS BUILD_HOST CONFIG_SITE
pankso@1 408 local LC_ALL=POSIX LANG=POSIX
pankso@1 409
pankso@126 410 # Check for build deps and handle implicit depends of *-dev packages
pankso@126 411 # (ex: libusb-dev :: libusb).
pankso@1 412 cd $INSTALLED && ls -1 > $CACHE/installed.list
pankso@1 413 [ "$DEPENDS" ] && gettext -e "Checking build dependencies...\n"
pankso@1 414 for dep in $BUILD_DEPENDS
pankso@1 415 do
pankso@126 416 implicit=${dep%-dev}
pankso@131 417 for i in $dep $implicit
pankso@126 418 do
pankso@131 419 if [ ! -f "$INSTALLED/$i/receipt" ]; then
pankso@126 420 # Try local package first.
pankso@131 421 vers=$(grep ^VERSION $WOK/$i/receipt | cut -d '"' -f 2)
pankso@131 422 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
pankso@131 423 gettext "Installing dep (pkg/local):"; echo " $i"
pankso@131 424 cd $PKGS && tazpkg install $i-$vers.tazpkg >/dev/null
pankso@126 425 else
pankso@131 426 gettext "Installing dep (web/cache):"; echo " $i"
pankso@131 427 tazpkg get-install $i >/dev/null
pankso@126 428 fi
pankso@1 429 fi
pankso@126 430 done
pankso@1 431 done
pankso@128 432 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
pankso@8 433
paul@62 434 # If a cook failed deps are not removed since we exit 1.
pankso@113 435 [ ! -s "installed.cook.diff" ] && \
pankso@141 436 busybox diff installed.list installed.cook > installed.cook.diff
pankso@113 437 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@1 438
pankso@1 439 # Get source tarball and make sure we have source dir named:
paul@62 440 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
paul@62 441 # tarball if it exists.
pankso@1 442 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
pankso@1 443 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
pankso@10 444 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
pankso@1 445 else
pankso@1 446 get_source || exit 1
pankso@1 447 fi
pankso@1 448 fi
pankso@9 449 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
pankso@1 450 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
pankso@1 451 extract_source || exit 1
paul@62 452 # Some archives are not well done and don't extract to one dir (ex lzma).
pankso@57 453 files=$(ls | wc -l)
pankso@57 454 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
pankso@57 455 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
pankso@57 456 mv * ../$PACKAGE-$VERSION
pankso@1 457 cd .. && rm -rf tmp
pankso@1 458 fi
pankso@1 459
pankso@9 460 # Execute receipt rules.
pankso@44 461 if grep -q ^compile_rules $receipt; then
pankso@1 462 gettext -e "Executing: compile_rules\n"
pankso@55 463 [ -d "$src" ] && cd $src
pankso@97 464 compile_rules $@ || exit 1
pankso@10 465 # Stay compatible with _pkg
pankso@55 466 [ -d "$src/_pkg" ] && mv $src/_pkg $install
pankso@9 467 # QA: compile_rules success so valid.
pankso@9 468 mkdir -p $install
pankso@9 469 else
pankso@9 470 # QA: No compile_rules so no error, valid.
pankso@9 471 mkdir -p $install
pankso@1 472 fi
pankso@1 473 separator && echo ""
pankso@1 474 }
pankso@1 475
pankso@1 476 # Cook quality assurance.
pankso@1 477 cookit_quality() {
pankso@9 478 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
pankso@15 479 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
pankso@9 480 fi
pankso@9 481 # ERROR can be echoed any time in cookit()
pankso@33 482 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@17 483 debug_info | tee -a $LOGS/$pkg.log
pankso@33 484 rm -f $command && exit 1
pankso@1 485 fi
pankso@1 486 }
pankso@1 487
pankso@16 488 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
paul@62 489 # but it doesn't handle EXTRAVERSION.
pankso@1 490 packit() {
pankso@1 491 set_paths
pankso@55 492 echo "Pack: $PACKAGE $VERSION"
pankso@1 493 separator
pankso@44 494 if grep -q ^genpkg_rules $receipt; then
pankso@16 495 gettext -e "Executing: genpkg_rules\n"
pankso@16 496 cd $pkgdir
pankso@98 497 mkdir -p $fs && genpkg_rules || echo -e \
pankso@98 498 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
pankso@16 499 fi
pankso@98 500
pankso@98 501 # First QA check to stop now if genpkg_rules failed.
pankso@98 502 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@98 503 exit 1
pankso@98 504 fi
pankso@98 505
pankso@44 506 cd $taz
pankso@1 507 for file in receipt description.txt
pankso@1 508 do
pankso@1 509 [ ! -f "../$file" ] && continue
pankso@1 510 gettext "Copying"; echo -n " $file..."
pankso@1 511 cp -f ../$file $pack && chown 0.0 $pack/$file && status
pankso@1 512 done
pankso@119 513 copy_generic_files
pankso@16 514
paul@62 515 # Create files.list with redirecting find output.
pankso@16 516 gettext "Creating the list of files..." && cd $fs
pankso@16 517 find . -type f -print > ../files.list
pankso@16 518 find . -type l -print >> ../files.list
pankso@16 519 cd .. && sed -i s/'^.'/''/ files.list
pankso@16 520 status
pankso@43 521
pankso@119 522 # Strip and stuff files.
pankso@43 523 strip_package
pankso@43 524
pankso@43 525 # Md5sum of files.
pankso@16 526 gettext "Creating md5sum of files..."
pankso@16 527 while read file; do
pankso@16 528 [ -L "fs$file" ] && continue
pankso@16 529 [ -f "fs$file" ] || continue
pankso@16 530 case "$file" in
pankso@16 531 /lib/modules/*/modules.*|*.pyc) continue;;
pankso@16 532 esac
pankso@16 533 md5sum "fs$file" | sed 's/ fs/ /'
pankso@16 534 done < files.list > md5sum
pankso@16 535 status
pankso@16 536 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
pankso@16 537 description.txt 2> /dev/null | awk \
pankso@16 538 '{ sz=$1 } END { print sz }')
pankso@16 539
pankso@16 540 # Build cpio archives.
pankso@16 541 gettext "Compressing the fs... "
pankso@16 542 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
pankso@16 543 rm -rf fs
pankso@16 544 status
pankso@16 545 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
pankso@16 546 md5sum description.txt 2> /dev/null | awk \
pankso@16 547 '{ sz=$1 } END { print sz }')
pankso@16 548 gettext "Updating receipt sizes..."
pankso@16 549 sed -i s/^PACKED_SIZE.*$// receipt
pankso@16 550 sed -i s/^UNPACKED_SIZE.*$// receipt
pankso@16 551 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
pankso@16 552 status
pankso@16 553
pankso@16 554 # Set extra version.
pankso@16 555 if [ "$EXTRAVERSION" ]; then
pankso@16 556 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
pankso@16 557 sed -i s/^EXTRAVERSION.*$// receipt
pankso@16 558 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
pankso@16 559 status
pankso@16 560 fi
pankso@16 561
pankso@16 562 # Compress.
pankso@16 563 gettext "Creating full cpio archive... "
pankso@16 564 find . -print | cpio -o -H newc --quiet > \
pankso@16 565 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
pankso@16 566 status
pankso@16 567 gettext "Restoring original package tree... "
pankso@16 568 unlzma -c fs.cpio.lzma | cpio -idm --quiet
pankso@16 569 status
pankso@16 570 rm fs.cpio.lzma && cd ..
pankso@43 571
pankso@43 572 # QA and give info.
pankso@43 573 tazpkg=$(ls *.tazpkg)
pankso@43 574 packit_quality
pankso@43 575 separator && gettext "Package:"; echo -e " $tazpkg\n"
pankso@1 576 }
pankso@1 577
paul@62 578 # Verify package quality and consistency.
pankso@8 579 packit_quality() {
pankso@142 580 gettext "QA: Checking for broken link..."
pankso@143 581 link=$(find $taz -type l -follow)
pankso@143 582 [ "$link" ] && echo -e "\nERROR: broken link in filesystem"
pankso@143 583 status
pankso@142 584
pankso@142 585 # Exit if any error found in log file.
pankso@33 586 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@32 587 rm -f $command && exit 1
pankso@8 588 fi
pankso@142 589
pankso@44 590 gettext "QA: Checking for empty package..."
pankso@45 591 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
pankso@45 592 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
pankso@44 593 echo -e "\nERROR: empty package"
pankso@32 594 rm -f $command && exit 1
pankso@8 595 else
pankso@134 596 # Ls sort by name so the first file is the one we want.
pankso@136 597 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
pankso@134 598 status
pankso@135 599 [ "$old" ] && echo -n "Removing old: $(basename $old)" && \
pankso@135 600 rm -f $old && status
pankso@134 601 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
pankso@11 602 sed -i /^${pkg}$/d $broken
pankso@8 603 fi
pankso@8 604 }
pankso@8 605
pankso@1 606 #
pankso@1 607 # Commands
pankso@1 608 #
pankso@1 609
pankso@1 610 case "$1" in
pankso@32 611 usage|help|-u|-h)
pankso@1 612 usage ;;
pankso@1 613 list-wok)
pankso@52 614 gettext -e "\nList of packages in:"; echo " $WOK"
pankso@1 615 separator
pankso@1 616 cd $WOK && ls -1
pankso@1 617 separator
pankso@1 618 echo -n "Packages: " && ls | wc -l
pankso@1 619 echo "" ;;
pankso@69 620 search)
pankso@69 621 # Just a simple search function, we dont need more actually.
pankso@69 622 query="$2"
pankso@69 623 gettext -e "\nSearch results for:"; echo " $query"
pankso@69 624 separator
pankso@69 625 cd $WOK && ls -1 | grep "$query"
pankso@69 626 separator && echo "" ;;
pankso@1 627 setup)
pankso@1 628 # Setup a build environment
pankso@1 629 check_root
pankso@11 630 echo "Cook: setting up the environment" | log
pankso@1 631 gettext -e "\nSetting up your environment\n"
pankso@1 632 separator && cd $SLITAZ
pankso@52 633 init_db_files
pankso@1 634 gettext -e "Checking for packages to install...\n"
pankso@29 635 for pkg in $SETUP_PKGS
pankso@1 636 do
pankso@52 637 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
pankso@1 638 done
pankso@1 639
pankso@1 640 # Handle --options
pankso@1 641 case "$2" in
pankso@49 642 --wok|-w)
pankso@52 643 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
pankso@52 644 tazpkg get-install mercurial
paul@62 645 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
pankso@1 646 hg clone $HG_URL ;;
pankso@1 647 esac
pankso@1 648
pankso@1 649 # SliTaz group and permissions
pankso@1 650 if ! grep -q ^slitaz /etc/group; then
pankso@1 651 gettext -e "Adding group: slitaz\n"
pankso@1 652 addgroup slitaz
pankso@1 653 fi
pankso@1 654 gettext -e "Setting permissions for slitaz group...\n"
pankso@1 655 chown -R root.slitaz $SLITAZ
pankso@1 656 chmod -R g+w $SLITAZ
pankso@1 657 separator
pankso@1 658 gettext -e "All done, ready to cook packages :-)\n\n" ;;
pankso@9 659 test)
pankso@9 660 # Test a cook environment.
pankso@13 661 echo "Cook test: testing the cook environment" | log
pankso@9 662 [ ! -d "$WOK" ] && exit 1
pankso@9 663 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
pankso@9 664 cook cooktest ;;
pankso@1 665 new)
pankso@1 666 # Create the package folder and an empty receipt.
pankso@1 667 pkg="$2"
pankso@1 668 [ "$pkg" ] || usage
pankso@60 669 [ -d "${WOK}-hg" ] && WOK=${WOK}-hg
pankso@1 670 echo ""
pankso@1 671 if [ -d "$WOK/$pkg" ]; then
paul@62 672 echo -n "$pkg " && gettext "package already exists."
pankso@1 673 echo -e "\n" && exit 1
pankso@1 674 fi
pankso@1 675 gettext "Creating"; echo -n " $WOK/$pkg"
pankso@1 676 mkdir $WOK/$pkg && cd $WOK/$pkg && status
pankso@1 677 gettext "Preparing the package receipt..."
pankso@1 678 cp $DATA/receipt .
pankso@1 679 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
pankso@1 680 status && echo "" ;;
pankso@1 681 list)
pankso@1 682 # Cook a list of packages (better use the Cooker since it will order
pankso@1 683 # packages before executing cook).
pankso@1 684 check_root
pankso@1 685 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
pankso@1 686 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
pankso@1 687 echo -e " $2\n" && exit 1
pankso@13 688 echo "Cook list starting: $2" | log
pankso@1 689 for pkg in $(cat $2)
pankso@1 690 do
pankso@1 691 cook $pkg || broken
pankso@1 692 done ;;
pankso@1 693 clean-wok)
pankso@1 694 check_root
pankso@1 695 gettext -e "\nCleaning all packages files..."
pankso@1 696 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
pankso@1 697 status && echo "" ;;
pankso@1 698 clean-src)
pankso@1 699 check_root
paul@62 700 gettext -e "\nCleaning all packages sources..."
pankso@1 701 rm -rf $WOK/*/source
pankso@1 702 status && echo "" ;;
pankso@1 703 pkglist)
paul@62 704 # Create suitable packages list for TazPKG and only for built packages.
pankso@1 705 [ "$2" ] && PKGS="$2"
pankso@1 706 [ ! -d "$PKGS" ] && \
paul@62 707 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
pankso@133 708 echo "cook:pkglist" > $command
paul@62 709 echo "Cook pkglist: Creating all packages lists" | log
pankso@1 710 gettext -e "\nCreating lists for:"; echo " $PKGS"
pankso@1 711 separator
pankso@133 712 cd $PKGS
pankso@1 713 rm -f packages.* files.list*
pankso@1 714 gettext -e "Creating: packages.list\n"
pankso@85 715 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
pankso@1 716 gettext -e "Creating: packages.md5\n"
pankso@1 717 md5sum *.tazpkg > $PKGS/packages.md5
pankso@1 718 gettext -e "Creating: packages.desc\n"
pankso@1 719 gettext -e "Creating: packages.equiv\n"
pankso@1 720 cd $WOK
pankso@1 721 for pkg in *
pankso@1 722 do
pankso@1 723 unset_receipt
pankso@1 724 . $pkg/receipt
pankso@1 725 # packages.desc let us search easily in DB
pankso@1 726 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 727 cat >> $PKGS/packages.desc << EOT
pankso@1 728 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
pankso@1 729 EOT
pankso@1 730 # Packages.equiv is used by tazpkg install to check depends.
pankso@1 731 for i in $PROVIDE; do
pankso@1 732 DEST=""
pankso@1 733 echo $i | fgrep -q : && DEST="${i#*:}:"
pankso@1 734 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
pankso@1 735 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
pankso@1 736 $PKGS/packages.equiv
pankso@1 737 else
pankso@1 738 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
pankso@1 739 fi
pankso@1 740 done
pankso@1 741 fi
pankso@1 742 done
pankso@1 743 # files.list.lzma
pankso@1 744 #lzma e files.list files.list.lzma
pankso@1 745 separator
pankso@1 746 nb=$(ls $PKGS/*.tazpkg | wc -l)
pankso@133 747 echo -e "Packages: $nb\n"
pankso@133 748 rm -f $command ;;
pankso@1 749 *)
pankso@1 750 # Just cook and generate a package.
pankso@1 751 check_root
pankso@1 752 time=$(date +%s)
pankso@1 753 pkg="$1"
pankso@1 754 [ -z "$pkg" ] && usage
pankso@44 755 receipt="$WOK/$pkg/receipt"
pankso@1 756 check_pkg_in_wok && echo ""
pankso@47 757
pankso@128 758 # Display and log info if cook process stopped.
pankso@128 759 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
pankso@128 760 tee -a $LOGS/$pkg.log' INT
pankso@128 761
pankso@47 762 # Skip blocked, 3 lines also for the Cooker.
pankso@51 763 if grep -q "^$pkg$" $blocked && [ "$2" != "--*" ]; then
pankso@47 764 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
pankso@47 765 fi
pankso@47 766
pankso@47 767 # Log and source receipt.
pankso@56 768 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
pankso@16 769 echo "cook:$pkg" > $command
pankso@1 770 unset inst
pankso@1 771 unset_receipt
pankso@44 772 . $receipt
pankso@1 773
pankso@1 774 # Handle --options
pankso@1 775 case "$2" in
pankso@1 776 --clean|-c)
pankso@49 777 gettext -e "Cleaning:"; echo -n " $pkg"
pankso@1 778 cd $WOK/$pkg && rm -rf install taz source
pankso@1 779 status && echo "" && exit 0 ;;
pankso@1 780 --install|-i)
pankso@1 781 inst='yes' ;;
pankso@49 782 --getsrc|-gs)
pankso@49 783 gettext "Getting source for:"; echo " $pkg"
pankso@45 784 separator && get_source
pankso@39 785 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
pankso@49 786 --block|-b)
pankso@49 787 gettext "Blocking:"; echo -n " $pkg"
pankso@49 788 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
pankso@49 789 status && echo "" && exit 0 ;;
pankso@49 790 --unblock|-ub)
pankso@49 791 gettext "Unblocking:"; echo -n " $pkg"
pankso@49 792 sed -i "/^${pkg}$/"d $blocked
pankso@49 793 status && echo "" && exit 0 ;;
pankso@1 794 esac
pankso@1 795
paul@62 796 # Check if wanted is built now so we have separate log files.
pankso@1 797 if [ "$WANTED" ] && [ ! -d "$WOK/$WANTED/install" ]; then
pankso@138 798 if ! grep -q "^$WANTED$" $broken; then
pankso@137 799 cook "$WANTED"
pankso@137 800 fi
pankso@1 801 fi
pankso@1 802
pankso@1 803 # Cook and pack or exit on error and log everything.
pankso@97 804 cookit $@ 2>&1 | tee $LOGS/$pkg.log
pankso@15 805 remove_deps | tee -a $LOGS/$pkg.log
pankso@1 806 cookit_quality
pankso@26 807 packit 2>&1 | tee -a $LOGS/$pkg.log
pankso@1 808 clean_log
pankso@33 809
pankso@33 810 # Exit if any error in packing.
pankso@33 811 if grep -q ^ERROR $LOGS/$pkg.log; then
pankso@33 812 debug_info | tee -a $LOGS/$pkg.log
pankso@33 813 rm -f $command && exit 1
pankso@33 814 fi
pankso@16 815
pankso@1 816 # Time and summary
pankso@1 817 time=$(($(date +%s) - $time))
pankso@1 818 summary | tee -a $LOGS/$pkg.log
pankso@50 819 echo ""
pankso@1 820
pankso@1 821 # Install package if requested
pankso@1 822 if [ "$inst" ]; then
pankso@1 823 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 824 cd $PKGS && tazpkg install \
pankso@1 825 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
pankso@1 826 else
paul@62 827 gettext -e "Unable to install package, build has failed.\n\n"
pankso@1 828 exit 1
pankso@1 829 fi
pankso@1 830 fi
pankso@9 831 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
pankso@17 832 # You want automation: use the Cooker Build Bot.
pankso@1 833 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
pankso@18 834 rm -f $command ;;
pankso@1 835 esac
pankso@1 836
pankso@1 837 exit 0